Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45284)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45285)
@@ -624,5 +624,5 @@
                               "the machine without doing a proper shutdown of the guest OS.</p>")
                               .arg(strNames),
-                           0 /* pcszAutoConfirmId */,
+                           0 /* auto-confirm id */,
                            tr("Discard", "saved state"));
 }
@@ -635,5 +635,5 @@
                               "in applications running inside it to be lost.</p>")
                               .arg(strNames),
-                           "confirmVMReset" /* pcszAutoConfirmId */,
+                           "confirmVMReset" /* auto-confirm id */,
                            tr("Reset", "machine"));
 }
@@ -645,5 +645,5 @@
                               "to the following virtual machines?</p><p><b>%1</b></p>")
                               .arg(strNames),
-                           "confirmVMACPIShutdown" /* pcszAutoConfirmId */,
+                           "confirmVMACPIShutdown" /* auto-confirm id */,
                            tr("ACPI Shutdown", "machine"));
 }
@@ -656,5 +656,5 @@
                               "running inside it to be lost.</p>")
                               .arg(strNames),
-                           "confirmVMPowerOff" /* pcszAutoConfirmId */,
+                           "confirmVMPowerOff" /* auto-confirm id */,
                            tr("Power Off", "machine"));
 }
@@ -682,5 +682,5 @@
 }
 
-int UIMessageCenter::askAboutSnapshotRestoring(const QString &strSnapshotName, bool fAlsoCreateNewSnapshot)
+int UIMessageCenter::confirmSnapshotRestoring(const QString &strSnapshotName, bool fAlsoCreateNewSnapshot)
 {
     return fAlsoCreateNewSnapshot ?
@@ -691,5 +691,5 @@
                                 .arg(strSnapshotName),
                              tr("Create a snapshot of the current machine state"),
-                             !vboxGlobal().virtualBox().GetExtraDataStringList(GUI_InvertMessageOption).contains("askAboutSnapshotRestoring"),
+                             !vboxGlobal().virtualBox().GetExtraDataStringList(GUI_InvertMessageOption).contains("confirmSnapshotRestoring"),
                              QString() /* details */,
                              QIMessageBox::Ok | QIMessageBox::Default,
@@ -699,5 +699,5 @@
            message(mainWindowShown(), MessageType_Question,
                    tr("<p>Are you sure you want to restore snapshot <nobr><b>%1</b></nobr>?</p>").arg(strSnapshotName),
-                   0 /* auto-confirmation token */,
+                   0 /* auto-confirm id */,
                    QIMessageBox::Ok | QIMessageBox::Default,
                    QIMessageBox::Cancel | QIMessageBox::Escape,
@@ -706,17 +706,16 @@
 }
 
-bool UIMessageCenter::askAboutSnapshotDeleting(const QString &strSnapshotName)
+bool UIMessageCenter::confirmSnapshotRemoval(const QString &strSnapshotName)
 {
     return messageOkCancel(mainWindowShown(), MessageType_Question,
-        tr("<p>Deleting the snapshot will cause the state information saved in it to be lost, and disk data spread over "
-            "several image files that VirtualBox has created together with the snapshot will be merged into one file. This can be a lengthy process, and the information "
-            "in the snapshot cannot be recovered.</p></p>Are you sure you want to delete the selected snapshot <b>%1</b>?</p>")
-            .arg(strSnapshotName),
-        /* Do NOT allow this message to be disabled! */
-        NULL /* pcszAutoConfirmId */,
-        tr("Delete"), tr("Cancel"));
-}
-
-bool UIMessageCenter::askAboutSnapshotDeletingFreeSpace(const QString &strSnapshotName,
+                           tr("<p>Deleting the snapshot will cause the state information saved in it to be lost, and disk data spread over "
+                              "several image files that VirtualBox has created together with the snapshot will be merged into one file. This can be a lengthy process, and the information "
+                              "in the snapshot cannot be recovered.</p></p>Are you sure you want to delete the selected snapshot <b>%1</b>?</p>")
+                              .arg(strSnapshotName),
+                           0 /* auto-confirm id */,
+                           tr("Delete"), tr("Cancel"));
+}
+
+bool UIMessageCenter::warnAboutSnapshotRemovalFreeSpace(const QString &strSnapshotName,
                                                         const QString &strTargetImageName,
                                                         const QString &strTargetImageMaxSize,
@@ -724,54 +723,54 @@
 {
     return messageOkCancel(mainWindowShown(), MessageType_Question,
-        tr("<p>Deleting the snapshot %1 will temporarily need more disk space. In the worst case the size of image %2 will grow by %3, "
-            "however on this filesystem there is only %4 free.</p><p>Running out of disk space during the merge operation can result in "
-            "corruption of the image and the VM configuration, i.e. loss of the VM and its data.</p><p>You may continue with deleting "
-            "the snapshot at your own risk.</p>")
-            .arg(strSnapshotName)
-            .arg(strTargetImageName)
-            .arg(strTargetImageMaxSize)
-            .arg(strTargetFileSystemFree),
-        /* Do NOT allow this message to be disabled! */
-        NULL /* pcszAutoConfirmId */,
-        tr("Delete"), tr("Cancel"));
-}
-
-void UIMessageCenter::cannotRestoreSnapshot(const CConsole &console,
-                                            const QString &strSnapshotName)
+                           tr("<p>Deleting the snapshot %1 will temporarily need more disk space. In the worst case the size of image %2 will grow by %3, "
+                               "however on this filesystem there is only %4 free.</p><p>Running out of disk space during the merge operation can result in "
+                               "corruption of the image and the VM configuration, i.e. loss of the VM and its data.</p><p>You may continue with deleting "
+                               "the snapshot at your own risk.</p>")
+                               .arg(strSnapshotName)
+                               .arg(strTargetImageName)
+                               .arg(strTargetImageMaxSize)
+                               .arg(strTargetFileSystemFree),
+                           0 /* auto-confirm id */,
+                           tr("Delete"));
+}
+
+void UIMessageCenter::cannotRestoreSnapshot(const CConsole &console, const QString &strSnapshotName)
 {
     message(mainWindowShown(), MessageType_Error,
-        tr("Failed to restore the snapshot <b>%1</b> of the virtual machine <b>%2</b>.")
-            .arg(strSnapshotName)
-            .arg(CConsole(console).GetMachine().GetName()),
-        formatErrorInfo(console));
-}
-
-void UIMessageCenter::cannotRestoreSnapshot(const CProgress &progress,
-                                            const QString &strSnapshotName)
-{
+            tr("Failed to restore the snapshot <b>%1</b> of the virtual machine <b>%2</b>.")
+               .arg(strSnapshotName).arg(CConsole(console).GetMachine().GetName()),
+            formatErrorInfo(console));
+}
+
+void UIMessageCenter::cannotRestoreSnapshot(const CProgress &progress, const QString &strSnapshotName)
+{
+    /* Get console: */
+    AssertWrapperOk(progress);
     CConsole console(CProgress(progress).GetInitiator());
-
+    AssertWrapperOk(console);
+    /* Show the message: */
     message(mainWindowShown(), MessageType_Error,
-        tr("Failed to restore the snapshot <b>%1</b> of the virtual machine <b>%2</b>.")
-            .arg(strSnapshotName)
-            .arg(console.GetMachine().GetName()),
-        formatErrorInfo(progress.GetErrorInfo()));
-}
-
-void UIMessageCenter::cannotDeleteSnapshot(const CConsole &console,
+            tr("Failed to restore the snapshot <b>%1</b> of the virtual machine <b>%2</b>.")
+               .arg(strSnapshotName).arg(console.GetMachine().GetName()),
+            formatErrorInfo(progress.GetErrorInfo()));
+}
+
+void UIMessageCenter::cannotRemoveSnapshot(const CConsole &console, const QString &strSnapshotName)
+{
+    message(mainWindowShown(), MessageType_Error,
+            tr("Failed to delete the snapshot <b>%1</b> of the virtual machine <b>%2</b>.")
+               .arg(strSnapshotName)
+               .arg(CConsole(console).GetMachine().GetName()),
+            formatErrorInfo(console));
+}
+
+void UIMessageCenter::cannotRemoveSnapshot(const CProgress &progress,
                                            const QString &strSnapshotName)
 {
-    message(mainWindowShown(), MessageType_Error,
-        tr("Failed to delete the snapshot <b>%1</b> of the virtual machine <b>%2</b>.")
-            .arg(strSnapshotName)
-            .arg(CConsole(console).GetMachine().GetName()),
-        formatErrorInfo(console));
-}
-
-void UIMessageCenter::cannotDeleteSnapshot(const CProgress &progress,
-                                           const QString &strSnapshotName)
-{
+    /* Get console: */
+    AssertWrapperOk(progress);
     CConsole console(CProgress(progress).GetInitiator());
-
+    AssertWrapperOk(console);
+    /* Show the message: */
     message(mainWindowShown(), MessageType_Error,
         tr("Failed to delete the snapshot <b>%1</b> of the virtual machine <b>%2</b>.")
@@ -779,15 +778,4 @@
             .arg(console.GetMachine().GetName()),
         formatErrorInfo(progress.GetErrorInfo()));
-}
-
-void UIMessageCenter::cannotFindSnapshotByName(QWidget *pParent,
-                                               const CMachine &machine,
-                                               const QString &strName) const
-{
-    message(pParent ? pParent : mainWindowShown(), MessageType_Error,
-             tr("Can't find snapshot named <b>%1</b>.")
-             .arg(strName),
-             formatErrorInfo(machine)
-    );
 }
 
@@ -879,5 +867,5 @@
                       "<p>Would you like to create a new, empty file to hold the disk contents or select an existing one?</p>")
                    .arg(strControllerName),
-                   0, /* pcszAutoConfirmId */
+                   0, /* auto-confirm id */
                    QIMessageBox::Yes,
                    QIMessageBox::No,
@@ -895,5 +883,5 @@
                       "or to leave it empty for now?</p>")
                    .arg(strControllerName),
-                   0, /* pcszAutoConfirmId */
+                   0, /* auto-confirm id */
                    QIMessageBox::Yes,
                    QIMessageBox::No,
@@ -911,5 +899,5 @@
                       "or to leave it empty for now?</p>")
                    .arg(strControllerName),
-                   0, /* pcszAutoConfirmId */
+                   0, /* auto-confirm id */
                    QIMessageBox::Yes,
                    QIMessageBox::No,
@@ -925,5 +913,5 @@
                                "<p>You will not be able to mount any CDs or ISO images "
                                "or install the Guest Additions without it!</p>"),
-                            0, /* pcszAutoConfirmId */
+                            0, /* auto-confirm id */
                             tr("&Remove", "medium"));
 }
@@ -941,5 +929,5 @@
            "you correct their settings by either choosing a different interface "
            "name or a different adapter attachment type.</p>").arg(strName),
-        0, /* pcszAutoConfirmId */
+        0, /* auto-confirm id */
         QIMessageBox::Ok | QIMessageBox::Default,
         QIMessageBox::Cancel | QIMessageBox::Escape);
@@ -985,5 +973,5 @@
             .arg(aMedium.location())
             .arg(strUsage),
-        0 /* pcszAutoConfirmId */,
+        0 /* auto-confirm id */,
         tr("Release", "detach medium"));
 }
@@ -1025,5 +1013,5 @@
 
     return messageOkCancel(pParent, MessageType_Question, msg,
-        "confirmRemoveMedium", /* pcszAutoConfirmId */
+        "confirmRemoveMedium", /* auto-confirm id */
         tr("Remove", "medium"));
 }
@@ -1042,5 +1030,5 @@
            "disk to the list later again.</p>")
         .arg(strLocation),
-        0, /* pcszAutoConfirmId */
+        0, /* auto-confirm id */
         QIMessageBox::Yes,
         QIMessageBox::No | QIMessageBox::Default,
@@ -1285,5 +1273,5 @@
            "until you add one. In the mean time you will only be able to start the "
            "machine using a virtual optical disk or from the network."),
-        0, /* pcszAutoConfirmId */
+        0, /* auto-confirm id */
         QIMessageBox::Ok,
         QIMessageBox::Cancel | QIMessageBox::Default | QIMessageBox::Escape,
@@ -1365,5 +1353,5 @@
            "will be discarded. The other machine(s) will not be changed.</p>", "This text is never used with n == 0.  Feel free to drop the %n where possible, we only included it because of problems with Qt Linguist (but the user can see how many machines are in the list and doesn't need to be told).",
            strMachineNames.size()).arg(VBoxGlobal::toHumanReadableList(strMachineNames)),
-        0 /* pcszAutoConfirmId */,
+        0 /* auto-confirm id */,
         tr("Continue"), tr("Cancel"));
 }
@@ -1420,4 +1408,14 @@
             tr("Failed to export appliance <b>%1</b>.").arg(pAppliance->GetPath()),
             formatErrorInfo(progress.GetErrorInfo()));
+}
+
+void UIMessageCenter::cannotFindSnapshotByName(QWidget *pParent,
+                                               const CMachine &machine,
+                                               const QString &strName) const
+{
+    message(pParent ? pParent : mainWindowShown(), MessageType_Error,
+            tr("Can't find snapshot named <b>%1</b>.")
+               .arg(strName),
+            formatErrorInfo(machine));
 }
 
@@ -1523,5 +1521,5 @@
                 "that you have enabled VT-x/AMD-V properly in the BIOS of your "
                 "host computer.</p>"),
-            0 /* pcszAutoConfirmId */,
+            0 /* auto-confirm id */,
             tr("Close VM"), tr("Continue"));
     else
@@ -1530,5 +1528,5 @@
                 "Your 64-bit guest will fail to detect a 64-bit CPU and will "
                 "not be able to boot."),
-            0 /* pcszAutoConfirmId */,
+            0 /* auto-confirm id */,
             tr("Close VM"), tr("Continue"));
 }
@@ -1543,5 +1541,5 @@
                 "that you have enabled VT-x/AMD-V properly in the BIOS of your "
                 "host computer.</p>"),
-            0 /* pcszAutoConfirmId */,
+            0 /* auto-confirm id */,
             tr("Close VM"), tr("Continue"));
     else
@@ -1550,5 +1548,5 @@
                 "Certain guests (e.g. OS/2 and QNX) require this feature and will "
                 "fail to boot without it.</p>"),
-            0 /* pcszAutoConfirmId */,
+            0 /* auto-confirm id */,
             tr("Close VM"), tr("Continue"));
 }
@@ -1565,5 +1563,5 @@
              .arg(strMachineName)
              .arg(strIfNames),
-             0, /* pcszAutoConfirmId */
+             0, /* auto-confirm id */
              tr("Change Network Settings"),
              tr("Close Virtual Machine"));
@@ -1583,8 +1581,9 @@
 void UIMessageCenter::cannotStartMachine(const CProgress &progress)
 {
+    /* Get console: */
     AssertWrapperOk(progress);
     CConsole console(CProgress(progress).GetInitiator());
     AssertWrapperOk(console);
-
+    /* Show the message: */
     message(
         mainWindowShown(),
@@ -1643,8 +1642,9 @@
 void UIMessageCenter::cannotSaveMachineState(const CProgress &progress)
 {
+    /* Get console: */
     AssertWrapperOk(progress);
     CConsole console(CProgress(progress).GetInitiator());
     AssertWrapperOk(console);
-
+    /* Show the message: */
     message(
         mainWindowShown(),
@@ -1669,8 +1669,9 @@
 void UIMessageCenter::cannotTakeSnapshot(const CProgress &progress)
 {
+    /* Get console: */
     AssertWrapperOk(progress);
     CConsole console(CProgress(progress).GetInitiator());
     AssertWrapperOk(console);
-
+    /* Show the message: */
     message(
         mainWindowShown(),
@@ -1684,8 +1685,9 @@
 void UIMessageCenter::cannotStopMachine(const CProgress &progress)
 {
+    /* Get console: */
     AssertWrapperOk(progress);
     CConsole console(CProgress(progress).GetInitiator());
     AssertWrapperOk(console);
-
+    /* Show the message: */
     message(mainWindowShown(), MessageType_Error,
         tr("Failed to stop the virtual machine <b>%1</b>.")
@@ -1803,5 +1805,5 @@
                "corresponding action from the menu bar."
                "</p>"),
-            kNames [1] /* pcszAutoConfirmId */);
+            kNames [1] /* auto-confirm id */);
     }
     else
@@ -1813,5 +1815,5 @@
                "display or pressing the host key) in order to use the "
                "mouse inside the guest OS.</p>"),
-            kNames [0] /* pcszAutoConfirmId */);
+            kNames [0] /* auto-confirm id */);
     }
 
@@ -1859,5 +1861,5 @@
                  "or press <b>Cancel</b> to cancel the operation.</p>")
              .arg(VBoxGlobal::formatSize(uMinVRAM)),
-             0, /* pcszAutoConfirmId */
+             0, /* auto-confirm id */
              QIMessageBox::Ignore | QIMessageBox::Default,
              QIMessageBox::Cancel | QIMessageBox::Escape);
@@ -1884,5 +1886,5 @@
                       "or press <b>Cancel</b> to cancel the operation.</p>")
                    .arg(VBoxGlobal::formatSize(uMinVRAM)),
-                   0, /* pcszAutoConfirmId */
+                   0, /* auto-confirm id */
                    QIMessageBox::Ignore | QIMessageBox::Default,
                    QIMessageBox::Cancel | QIMessageBox::Escape);
@@ -2033,5 +2035,5 @@
            "it is recommended to press <b>OK</b> now.</p>")
             .arg(strLogFolder),
-        0, /* pcszAutoConfirmId */
+        0, /* auto-confirm id */
         QIMessageBox::Ok | QIMessageBox::Default,
         QIMessageBox::Ignore | QIMessageBox::Escape);
@@ -2076,5 +2078,5 @@
                               "<nobr><a href=\"%1\">%2</a></nobr> "
                               "(size %3 bytes)?</p>").arg(strUrl).arg(strUrl).arg(loc.toString(uSize)),
-                           0, /* pcszAutoConfirmId */
+                           0, /* auto-confirm id */
                            tr("Download", "additions"));
 }
@@ -2090,5 +2092,5 @@
                               "on the virtual CD/DVD drive?</p>")
                                .arg(strUrl).arg(strUrl).arg(strSrc),
-                           0, /* pcszAutoConfirmId */
+                           0, /* auto-confirm id */
                            tr("Mount", "additions"));
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45284)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45285)
@@ -228,15 +228,12 @@
 
     /* API: Snapshot warnings: */
-    int askAboutSnapshotRestoring(const QString &strSnapshotName, bool fAlsoCreateNewSnapshot);
-    bool askAboutSnapshotDeleting(const QString &strSnapshotName);
-    bool askAboutSnapshotDeletingFreeSpace(const QString &strSnapshotName,
-                                           const QString &strTargetImageName,
-                                           const QString &strTargetImageMaxSize,
-                                           const QString &strTargetFileSystemFree);
+    int confirmSnapshotRestoring(const QString &strSnapshotName, bool fAlsoCreateNewSnapshot);
+    bool confirmSnapshotRemoval(const QString &strSnapshotName);
+    bool warnAboutSnapshotRemovalFreeSpace(const QString &strSnapshotName, const QString &strTargetImageName,
+                                           const QString &strTargetImageMaxSize, const QString &strTargetFileSystemFree);
     void cannotRestoreSnapshot(const CConsole &console, const QString &strSnapshotName);
     void cannotRestoreSnapshot(const CProgress &progress, const QString &strSnapshotName);
-    void cannotDeleteSnapshot(const CConsole &console, const QString &strSnapshotName);
-    void cannotDeleteSnapshot(const CProgress &progress, const QString &strSnapshotName);
-    void cannotFindSnapshotByName(QWidget *pParent, const CMachine &machine, const QString &strMachine) const;
+    void cannotRemoveSnapshot(const CConsole &console, const QString &strSnapshotName);
+    void cannotRemoveSnapshot(const CProgress &progress, const QString &strSnapshotName);
 
     /* API: Settings warnings: */
@@ -293,4 +290,5 @@
     void cannotExportAppliance(const CMachine &machine, CAppliance *pAppliance, QWidget *pParent = NULL) const;
     void cannotExportAppliance(const CProgress &progress, CAppliance *pAppliance, QWidget *pParent = NULL) const;
+    void cannotFindSnapshotByName(QWidget *pParent, const CMachine &machine, const QString &strMachine) const;
 
     /* API: Runtime UI warnings: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSnapshotsWgt.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSnapshotsWgt.cpp	(revision 45284)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSnapshotsWgt.cpp	(revision 45285)
@@ -584,5 +584,5 @@
 
     /* Ask the user if he really wants to restore the snapshot: */
-    int iResultCode = msgCenter().askAboutSnapshotRestoring(snapshot.GetName(), mMachine.GetCurrentStateModified());
+    int iResultCode = msgCenter().confirmSnapshotRestoring(snapshot.GetName(), mMachine.GetCurrentStateModified());
     if (iResultCode & QIMessageBox::Cancel)
         return;
@@ -613,5 +613,5 @@
     }
     else
-        msgCenter().cannotRestoreSnapshot(progress, snapshot.GetName());
+        msgCenter().cannotRestoreSnapshot(console, snapshot.GetName());
 
     /* Unlock machine finally: */
@@ -629,16 +629,15 @@
     CSnapshot snapshot = mMachine.FindSnapshot(snapId);
 
-    if (!msgCenter().askAboutSnapshotDeleting (snapshot.GetName()))
+    if (!msgCenter().confirmSnapshotRemoval(snapshot.GetName()))
         return;
 
     /** @todo check available space on the target filesystem etc etc. */
 #if 0
-    if (!msgCenter().askAboutSnapshotDeletingFreeSpace (snapshot.GetName(),
-                                                          "/home/juser/.VirtualBox/Machines/SampleVM/Snapshots/{01020304-0102-0102-0102-010203040506}.vdi",
-                                                          "59 GiB",
-                                                          "15 GiB"))
+    if (!msgCenter().warnAboutSnapshotRemovalFreeSpace(snapshot.GetName(),
+                                                       "/home/juser/.VirtualBox/Machines/SampleVM/Snapshots/{01020304-0102-0102-0102-010203040506}.vdi",
+                                                       "59 GiB",
+                                                       "15 GiB"))
         return;
 #endif
-
 
     /* Open a direct session (this call will handle all errors) */
@@ -661,8 +660,8 @@
 
         if (progress.GetResultCode() != 0)
-            msgCenter().cannotDeleteSnapshot (progress,  snapshot.GetName());
+            msgCenter().cannotRemoveSnapshot (progress,  snapshot.GetName());
     }
     else
-        msgCenter().cannotDeleteSnapshot (console,  snapshot.GetName());
+        msgCenter().cannotRemoveSnapshot (console,  snapshot.GetName());
 
     session.UnlockMachine();