Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.cpp	(revision 45296)
@@ -51,5 +51,5 @@
  */
 QIMessageBox::QIMessageBox (const QString &aCaption, const QString &aText,
-                            IconType aIcon, int aButton0, int aButton1, int aButton2,
+                            AlertIconType aIcon, int aButton0, int aButton1, int aButton2,
                             QWidget *aParent, const char *aName, bool aModal)
     : QIDialog (aParent)
@@ -156,7 +156,7 @@
     /* If this is an error message add an "Copy to clipboard" button for easier
      * bug reports. */
-    if (aIcon == QIMessageBox::IconType_Critical)
-    {
-        QPushButton *pCopyButton = createButton(Copy);
+    if (aIcon == AlertIconType_Critical)
+    {
+        QPushButton *pCopyButton = createButton(AlertButton_Copy);
         pCopyButton->setToolTip(tr("Copy all errors to the clipboard"));
         connect(pCopyButton, SIGNAL(clicked()), SLOT(copy()));
@@ -255,12 +255,12 @@
     QString text;
     QDialogButtonBox::ButtonRole role;
-    switch (aButton & ButtonMask)
-    {
-        case Ok:     text = tr("OK");     role = QDialogButtonBox::AcceptRole; break;
-        case Yes:    text = tr("Yes");    role = QDialogButtonBox::YesRole; break;
-        case No:     text = tr("No");     role = QDialogButtonBox::NoRole; break;
-        case Cancel: text = tr("Cancel"); role = QDialogButtonBox::RejectRole; break;
-        case Ignore: text = tr("Ignore"); role = QDialogButtonBox::AcceptRole; break;
-        case Copy:   text = tr("Copy");   role = QDialogButtonBox::ActionRole; break;
+    switch (aButton & AlertButtonMask)
+    {
+        case AlertButton_Ok:     text = tr("OK");     role = QDialogButtonBox::AcceptRole; break;
+        case AlertButton_Cancel: text = tr("Cancel"); role = QDialogButtonBox::RejectRole; break;
+        case AlertButton_Yes:    text = tr("Yes");    role = QDialogButtonBox::YesRole; break;
+        case AlertButton_No:     text = tr("No");     role = QDialogButtonBox::NoRole; break;
+        case AlertButton_Ignore: text = tr("Ignore"); role = QDialogButtonBox::AcceptRole; break;
+        case AlertButton_Copy:   text = tr("Copy");   role = QDialogButtonBox::ActionRole; break;
         default:
             AssertMsgFailed(("Type %d is not implemented", aButton));
@@ -270,5 +270,5 @@
     QPushButton *b = mButtonBox->addButton (text, role);
 
-    if (aButton & Default)
+    if (aButton & AlertButtonOption_Default)
     {
         b->setDefault (true);
@@ -276,6 +276,6 @@
     }
 
-    if (aButton & Escape)
-        mButtonEsc = aButton & ButtonMask;
+    if (aButton & AlertButtonOption_Escape)
+        mButtonEsc = aButton & AlertButtonMask;
 
     return b;
@@ -316,10 +316,10 @@
 }
 
-QPixmap QIMessageBox::standardPixmap (QIMessageBox::IconType aIcon)
+QPixmap QIMessageBox::standardPixmap(AlertIconType aIcon)
 {
     QIcon icon;
     switch (aIcon)
     {
-        case QIMessageBox::IconType_Information:
+        case AlertIconType_Information:
             icon = UIIconPool::defaultIcon(UIIconPool::MessageBoxInformationIcon, this);
             break;
@@ -327,11 +327,11 @@
             icon = UIIconPool::defaultIcon(UIIconPool::MessageBoxWarningIcon, this);
             break;
-        case QIMessageBox::IconType_Critical:
+        case AlertIconType_Critical:
             icon = UIIconPool::defaultIcon(UIIconPool::MessageBoxCriticalIcon, this);
             break;
-        case QIMessageBox::IconType_Question:
+        case AlertIconType_Question:
             icon = UIIconPool::defaultIcon(UIIconPool::MessageBoxQuestionIcon, this);
             break;
-        case QIMessageBox::IconType_GuruMeditation:
+        case AlertIconType_GuruMeditation:
             icon = QIcon(":/meditation_32px.png");
             break;
@@ -466,5 +466,5 @@
     {
         QDialog::reject();
-        setResult (mButtonEsc & ButtonMask);
+        setResult (mButtonEsc & AlertButtonMask);
     }
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.h	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIMessageBox.h	(revision 45296)
@@ -37,4 +37,43 @@
 class QILabel;
 
+/* Button type enumerator: */
+enum AlertButton
+{
+    AlertButton_NoButton      =  0x0,  /* 00000000 00000000 */
+    AlertButton_Ok            =  0x1,  /* 00000000 00000001 */
+    AlertButton_Cancel        =  0x2,  /* 00000000 00000010 */
+    AlertButton_Yes           =  0x4,  /* 00000000 00000100 */
+    AlertButton_No            =  0x8,  /* 00000000 00001000 */
+    AlertButton_Ignore        = 0x10,  /* 00000000 00010000 */
+    AlertButton_Copy          = 0x20,  /* 00000000 00100000 */
+    AlertButtonMask           = 0xFF   /* 00000000 11111111 */
+};
+
+/* Button option enumerator: */
+enum AlertButtonOption
+{
+    AlertButtonOption_Default = 0x100, /* 00000001 00000000 */
+    AlertButtonOption_Escape  = 0x200, /* 00000010 00000000 */
+    AlertButtonOptionMask     = 0x300  /* 00000011 00000000 */
+};
+
+/* Alert option enumerator: */
+enum AlertOption
+{
+    AlertOption_CheckBox      = 0x400, /* 00000100 00000000 */
+    AlertOptionMask           = 0xFC00 /* 11111100 00000000 */
+};
+
+/* Icon type enumerator: */
+enum AlertIconType
+{
+    AlertIconType_NoIcon = QMessageBox::NoIcon,
+    AlertIconType_Information = QMessageBox::Information,
+    AlertIconType_Warning = QMessageBox::Warning,
+    AlertIconType_Critical = QMessageBox::Critical,
+    AlertIconType_Question = QMessageBox::Question,
+    AlertIconType_GuruMeditation
+};
+
 /* QIDialog extension representing GUI alerts: */
 class QIMessageBox : public QIDialog
@@ -44,30 +83,7 @@
 public:
 
-    /* Icon type enumerator: */
-    enum IconType
-    {
-        IconType_NoIcon = QMessageBox::NoIcon,
-        IconType_Information = QMessageBox::Information,
-        IconType_Warning = QMessageBox::Warning,
-        IconType_Critical = QMessageBox::Critical,
-        IconType_Question = QMessageBox::Question,
-        IconType_GuruMeditation,
-    };
-
-    enum
-    {
-        NoButton = 0, Ok = 1, Cancel = 2, Yes = 3, No = 4, Abort = 5,
-        Retry = 6, Ignore = 7, YesAll = 8, NoAll = 9, Copy = 10,
-        ButtonMask = 0xFF,
-
-        Default = 0x100, Escape = 0x200,
-        FlagMask = 0x300,
-
-        OptionChosen = 0x400
-    };
-
-    QIMessageBox (const QString &aCaption, const QString &aText,
-                  IconType aIcon, int aButton0, int aButton1 = 0, int aButton2 = 0,
-                  QWidget *aParent = 0, const char *aName = 0, bool aModal = TRUE);
+    QIMessageBox(const QString &aCaption, const QString &aText,
+                 AlertIconType aIcon, int aButton0, int aButton1 = 0, int aButton2 = 0,
+                 QWidget *aParent = 0, const char *aName = 0, bool aModal = TRUE);
 
     QString buttonText (int aButton) const;
@@ -83,5 +99,5 @@
     void setDetailsText (const QString &aText);
 
-    QPixmap standardPixmap (QIMessageBox::IconType aIcon);
+    QPixmap standardPixmap(AlertIconType aIcon);
 
 private:
@@ -102,7 +118,7 @@
     void detailsNext();
 
-    void done0() { mWasDone = true; done (mButton0 & ButtonMask); }
-    void done1() { mWasDone = true; done (mButton1 & ButtonMask); }
-    void done2() { mWasDone = true; done (mButton2 & ButtonMask); }
+    void done0() { mWasDone = true; done (mButton0 & AlertButtonMask); }
+    void done1() { mWasDone = true; done (mButton1 & AlertButtonMask); }
+    void done2() { mWasDone = true; done (mButton2 & AlertButtonMask); }
 
     void reject();
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45296)
@@ -130,9 +130,9 @@
     /* If no buttons are set, using single 'OK' button: */
     if (iButton1 == 0 && iButton2 == 0 && iButton3 == 0)
-        iButton1 = QIMessageBox::Ok | QIMessageBox::Default;
+        iButton1 = AlertButton_Ok | AlertButtonOption_Default;
 
     /* Assign corresponding title and icon: */
     QString strTitle;
-    QIMessageBox::IconType icon;
+    AlertIconType icon;
     switch (type)
     {
@@ -140,25 +140,25 @@
         case MessageType_Info:
             strTitle = tr("VirtualBox - Information", "msg box title");
-            icon = QIMessageBox::IconType_Information;
+            icon = AlertIconType_Information;
             break;
         case MessageType_Question:
             strTitle = tr("VirtualBox - Question", "msg box title");
-            icon = QIMessageBox::IconType_Question;
+            icon = AlertIconType_Question;
             break;
         case MessageType_Warning:
             strTitle = tr("VirtualBox - Warning", "msg box title");
-            icon = QIMessageBox::IconType_Warning;
+            icon = AlertIconType_Warning;
             break;
         case MessageType_Error:
             strTitle = tr("VirtualBox - Error", "msg box title");
-            icon = QIMessageBox::IconType_Critical;
+            icon = AlertIconType_Critical;
             break;
         case MessageType_Critical:
             strTitle = tr("VirtualBox - Critical Error", "msg box title");
-            icon = QIMessageBox::IconType_Critical;
+            icon = AlertIconType_Critical;
             break;
         case MessageType_GuruMeditation:
             strTitle = "VirtualBox - Guru Meditation"; /* don't translate this */
-            icon = QIMessageBox::IconType_GuruMeditation;
+            icon = AlertIconType_GuruMeditation;
             break;
     }
@@ -196,5 +196,5 @@
     /* Save option: */
     if (pBox->isFlagChecked())
-        rc |= QIMessageBox::OptionChosen;
+        rc |= AlertOption_CheckBox;
 
     /* Delete message-box: */
@@ -572,13 +572,13 @@
            message(mainWindowShown(), MessageType_Question,
                    strText, 0 /* auto-confirm id */,
-                   QIMessageBox::Ok | QIMessageBox::Default,
-                   QIMessageBox::Cancel | QIMessageBox::Escape,
+                   AlertButton_Ok | AlertButtonOption_Default,
+                   AlertButton_Cancel | AlertButtonOption_Escape,
                    0,
                    tr("Remove")) :
            message(mainWindowShown(), MessageType_Question,
                    strText, 0 /* auto-confirm id */,
-                   QIMessageBox::Yes,
-                   QIMessageBox::No | QIMessageBox::Default,
-                   QIMessageBox::Cancel | QIMessageBox::Escape,
+                   AlertButton_Yes,
+                   AlertButton_No | AlertButtonOption_Default,
+                   AlertButton_Cancel | AlertButtonOption_Escape,
                    tr("Delete all files"),
                    tr("Remove only"));
@@ -697,6 +697,6 @@
                              !vboxGlobal().virtualBox().GetExtraDataStringList(GUI_InvertMessageOption).contains("confirmSnapshotRestoring"),
                              QString() /* details */,
-                             QIMessageBox::Ok | QIMessageBox::Default,
-                             QIMessageBox::Cancel | QIMessageBox::Escape,
+                             AlertButton_Ok | AlertButtonOption_Default,
+                             AlertButton_Cancel | AlertButtonOption_Escape,
                              0 /* 3rd button */,
                              tr("Restore"), tr("Cancel"), QString() /* 3rd button text */) :
@@ -705,6 +705,6 @@
                       .arg(strSnapshotName),
                    0 /* auto-confirm id */,
-                   QIMessageBox::Ok | QIMessageBox::Default,
-                   QIMessageBox::Cancel | QIMessageBox::Escape,
+                   AlertButton_Ok | AlertButtonOption_Default,
+                   AlertButton_Cancel | AlertButtonOption_Escape,
                    0 /* 3rd button */,
                    tr("Restore"), tr("Cancel"), QString() /* 3rd button text */);
@@ -866,7 +866,7 @@
                       .arg(strControllerName),
                    0 /* auto-confirm id */,
-                   QIMessageBox::Yes,
-                   QIMessageBox::No,
-                   QIMessageBox::Cancel | QIMessageBox::Default | QIMessageBox::Escape,
+                   AlertButton_Yes,
+                   AlertButton_No,
+                   AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
                    tr("Create &new disk", "add attachment routine"),
                    tr("&Choose existing disk", "add attachment routine"));
@@ -881,7 +881,7 @@
                       .arg(strControllerName),
                    0 /* auto-confirm id */,
-                   QIMessageBox::Yes,
-                   QIMessageBox::No,
-                   QIMessageBox::Cancel | QIMessageBox::Default | QIMessageBox::Escape,
+                   AlertButton_Yes,
+                   AlertButton_No,
+                   AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
                    tr("&Choose disk", "add attachment routine"),
                    tr("Leave &empty", "add attachment routine"));
@@ -896,7 +896,7 @@
                       .arg(strControllerName),
                    0 /* auto-confirm id */,
-                   QIMessageBox::Yes,
-                   QIMessageBox::No,
-                   QIMessageBox::Cancel | QIMessageBox::Default | QIMessageBox::Escape,
+                   AlertButton_Yes,
+                   AlertButton_No,
+                   AlertButton_Cancel | AlertButtonOption_Default | AlertButtonOption_Escape,
                    tr("&Choose disk", "add attachment routine"),
                    tr("Leave &empty", "add attachment routine"));
@@ -1033,7 +1033,7 @@
                       .arg(strLocation),
                    0 /* auto-confirm id */,
-                   QIMessageBox::Yes,
-                   QIMessageBox::No | QIMessageBox::Default,
-                   QIMessageBox::Cancel | QIMessageBox::Escape,
+                   AlertButton_Yes,
+                   AlertButton_No | AlertButtonOption_Default,
+                   AlertButton_Cancel | AlertButtonOption_Escape,
                    tr("Delete", "hard disk storage"),
                    tr("Keep", "hard disk storage"));
@@ -1321,9 +1321,9 @@
            "machine using a virtual optical disk or from the network."),
         0 /* auto-confirm id */,
-        QIMessageBox::Ok,
-        QIMessageBox::Cancel | QIMessageBox::Default | QIMessageBox::Escape,
+        AlertButton_Ok | AlertButtonOption_Default,
+        AlertButton_Cancel | AlertButtonOption_Escape,
         0,
         tr("Continue", "no hard disk attached"),
-        tr("Go Back", "no hard disk attached")) == QIMessageBox::Ok;
+        tr("Go Back", "no hard disk attached")) == AlertButton_Ok;
 }
 
@@ -1773,6 +1773,6 @@
             .arg(UIHostCombo::toReadableString(vboxGlobal().settings().hostCombo())),
         "confirmInputCapture",
-        QIMessageBox::Ok | QIMessageBox::Default,
-        QIMessageBox::Cancel | QIMessageBox::Escape,
+        AlertButton_Ok | AlertButtonOption_Default,
+        AlertButton_Cancel | AlertButtonOption_Escape,
         0,
         tr("Capture", "do input capture"));
@@ -1781,5 +1781,5 @@
         *pfAutoConfirmed = (rc & AutoConfirmed);
 
-    return (rc & QIMessageBox::ButtonMask) == QIMessageBox::Ok;
+    return (rc & AlertButtonMask) == AlertButton_Ok;
 }
 
@@ -1909,6 +1909,6 @@
              .arg(VBoxGlobal::formatSize(uMinVRAM)),
              0 /* auto-confirm id */,
-             QIMessageBox::Ignore | QIMessageBox::Default,
-             QIMessageBox::Cancel | QIMessageBox::Escape);
+             AlertButton_Ignore | AlertButtonOption_Default,
+             AlertButton_Cancel | AlertButtonOption_Escape);
 }
 
@@ -1934,6 +1934,6 @@
                    .arg(VBoxGlobal::formatSize(uMinVRAM)),
                    0 /* auto-confirm id */,
-                   QIMessageBox::Ignore | QIMessageBox::Default,
-                   QIMessageBox::Cancel | QIMessageBox::Escape);
+                   AlertButton_Ignore | AlertButtonOption_Default,
+                   AlertButton_Cancel | AlertButtonOption_Escape);
 }
 
@@ -2083,8 +2083,8 @@
             .arg(strLogFolder),
         0 /* auto-confirm id */,
-        QIMessageBox::Ok | QIMessageBox::Default,
-        QIMessageBox::Ignore | QIMessageBox::Escape);
-
-    return rc == QIMessageBox::Ok;
+        AlertButton_Ok | AlertButtonOption_Default,
+        AlertButton_Ignore | AlertButtonOption_Escape);
+
+    return rc == AlertButton_Ok;
 }
 
@@ -2212,5 +2212,5 @@
                       .arg(strExtPackVersion).arg(strExtPackName).arg(strVBoxVersion),
                       0 /* auto-confirm id */,
-                      QIMessageBox::Ok | QIMessageBox::Default,
+                      AlertButton_Ok | AlertButtonOption_Default,
                       0,
                       0,
@@ -2960,5 +2960,5 @@
     /* Choose the 'default' button: */
     if (iButton1 == 0 && iButton2 == 0 && iButton3 == 0)
-        iButton1 = QIMessageBox::Ok | QIMessageBox::Default;
+        iButton1 = AlertButton_Ok | AlertButtonOption_Default;
 
     /* Check if message-box was auto-confirmed before: */
@@ -2972,10 +2972,10 @@
         {
             int iResultCode = AutoConfirmed;
-            if (iButton1 & QIMessageBox::Default)
-                iResultCode |= (iButton1 & QIMessageBox::ButtonMask);
-            if (iButton2 & QIMessageBox::Default)
-                iResultCode |= (iButton2 & QIMessageBox::ButtonMask);
-            if (iButton3 & QIMessageBox::Default)
-                iResultCode |= (iButton3 & QIMessageBox::ButtonMask);
+            if (iButton1 & AlertButtonOption_Default)
+                iResultCode |= (iButton1 & AlertButtonMask);
+            if (iButton2 & AlertButtonOption_Default)
+                iResultCode |= (iButton2 & AlertButtonMask);
+            if (iButton3 & AlertButtonOption_Default)
+                iResultCode |= (iButton3 & AlertButtonMask);
             return iResultCode;
         }
@@ -2984,5 +2984,5 @@
     /* Choose title and icon: */
     QString title;
-    QIMessageBox::IconType icon;
+    AlertIconType icon;
     switch (type)
     {
@@ -2990,25 +2990,25 @@
         case MessageType_Info:
             title = tr("VirtualBox - Information", "msg box title");
-            icon = QIMessageBox::IconType_Information;
+            icon = AlertIconType_Information;
             break;
         case MessageType_Question:
             title = tr("VirtualBox - MessageType_Question", "msg box title");
-            icon = QIMessageBox::IconType_Question;
+            icon = AlertIconType_Question;
             break;
         case MessageType_Warning:
             title = tr("VirtualBox - MessageType_Warning", "msg box title");
-            icon = QIMessageBox::IconType_Warning;
+            icon = AlertIconType_Warning;
             break;
         case MessageType_Error:
             title = tr("VirtualBox - MessageType_Error", "msg box title");
-            icon = QIMessageBox::IconType_Critical;
+            icon = AlertIconType_Critical;
             break;
         case MessageType_Critical:
             title = tr("VirtualBox - MessageType_Critical MessageType_Error", "msg box title");
-            icon = QIMessageBox::IconType_Critical;
+            icon = AlertIconType_Critical;
             break;
         case MessageType_GuruMeditation:
             title = "VirtualBox - Guru Meditation"; /* don't translate this */
-            icon = QIMessageBox::IconType_GuruMeditation;
+            icon = AlertIconType_GuruMeditation;
             break;
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45296)
@@ -114,9 +114,9 @@
     {
         return (message(pParent, type, strMessage, strDetails, pcszAutoConfirmId,
-                        QIMessageBox::Yes | QIMessageBox::Default,
-                        QIMessageBox::No | QIMessageBox::Escape,
+                        AlertButton_Yes | AlertButtonOption_Default,
+                        AlertButton_No | AlertButtonOption_Escape,
                         0,
                         strYesButtonText, strNoButtonText, QString()) &
-                QIMessageBox::ButtonMask) == QIMessageBox::Yes;
+                AlertButtonMask) == AlertButton_Yes;
     }
 
@@ -143,11 +143,11 @@
                          bool fOkByDefault = true) const
     {
-        int iOkButton = fOkByDefault ? QIMessageBox::Ok | QIMessageBox::Default :
-                                       QIMessageBox::Ok;
-        int iCancelButton = fOkByDefault ? QIMessageBox::Cancel | QIMessageBox::Escape :
-                                           QIMessageBox::Cancel | QIMessageBox::Escape | QIMessageBox::Default;
+        int iOkButton = fOkByDefault ? AlertButton_Ok | AlertButtonOption_Default :
+                                       AlertButton_Ok;
+        int iCancelButton = fOkByDefault ? AlertButton_Cancel | AlertButtonOption_Escape :
+                                           AlertButton_Cancel | AlertButtonOption_Escape | AlertButtonOption_Default;
         return (message(pParent, type, strMessage, strDetails, pcszAutoConfirmId,
                         iOkButton, iCancelButton, 0, strOkButtonText, strCancelButtonText, QString()) &
-                QIMessageBox::ButtonMask) == QIMessageBox::Ok;
+                AlertButtonMask) == AlertButton_Ok;
     }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 45296)
@@ -1159,7 +1159,7 @@
             {
                 int rc = msgCenter().confirmDeleteHardDiskStorage(item->location(), this);
-                if (rc == QIMessageBox::Cancel)
+                if (rc == AlertButton_Cancel)
                     return;
-                deleteStorage = rc == QIMessageBox::Yes;
+                deleteStorage = rc == AlertButton_Yes;
             }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 45296)
@@ -1493,5 +1493,5 @@
         /* Ask for force remounting: */
         if (msgCenter().cannotRemountMedium(machine, vboxGlobal().findMedium(fMount ? newId : currentId),
-                                            fMount, true /* retry? */, activeMachineWindow()) == QIMessageBox::Ok)
+                                            fMount, true /* retry? */, activeMachineWindow()) == AlertButton_Ok)
         {
             /* Force remount medium to the predefined port/device: */
@@ -1554,5 +1554,5 @@
             /* Ask for force remounting: */
             if (msgCenter().cannotRemountMedium(machine, vboxGlobal().findMedium(fMount ? strNewId : strCurrentId),
-                                                fMount, true /* retry? */, activeMachineWindow()) == QIMessageBox::Ok)
+                                                fMount, true /* retry? */, activeMachineWindow()) == AlertButton_Ok)
             {
                 /* Force remount medium to the predefined port/device: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMultiScreenLayout.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMultiScreenLayout.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMultiScreenLayout.cpp	(revision 45296)
@@ -226,5 +226,5 @@
                 msgCenter().cannotSwitchScreenInSeamless((((usedBits + 7) / 8 + _1M - 1) / _1M) * _1M);
             else
-                fSuccess = msgCenter().cannotSwitchScreenInFullscreen((((usedBits + 7) / 8 + _1M - 1) / _1M) * _1M) != QIMessageBox::Cancel;
+                fSuccess = msgCenter().cannotSwitchScreenInFullscreen((((usedBits + 7) / 8 + _1M - 1) / _1M) * _1M) != AlertButton_Cancel;
         }
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 45296)
@@ -592,5 +592,5 @@
                 /* Ask for force mounting: */
                 if (msgCenter().cannotRemountMedium(machine, vboxMedium, true /* mount? */,
-                                                    true /* retry? */, mainMachineWindow()) == QIMessageBox::Ok)
+                                                    true /* retry? */, mainMachineWindow()) == AlertButton_Ok)
                 {
                     /* Force mount medium to the predefined port/device: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 45296)
@@ -62,5 +62,5 @@
             int result = msgCenter().cannotEnterFullscreenMode(0, 0, 0,
                                                                (((usedBits + 7) / 8 + _1M - 1) / _1M) * _1M);
-            if (result == QIMessageBox::Cancel)
+            if (result == AlertButton_Cancel)
                 return false;
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSnapshotsWgt.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSnapshotsWgt.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/VBoxSnapshotsWgt.cpp	(revision 45296)
@@ -585,9 +585,9 @@
     /* Ask the user if he really wants to restore the snapshot: */
     int iResultCode = msgCenter().confirmSnapshotRestoring(snapshot.GetName(), mMachine.GetCurrentStateModified());
-    if (iResultCode & QIMessageBox::Cancel)
+    if (iResultCode & AlertButton_Cancel)
         return;
 
     /* If user also confirmed new snapshot creation: */
-    if (iResultCode & QIMessageBox::OptionChosen)
+    if (iResultCode & AlertOption_CheckBox)
     {
         /* Take snapshot of changed current state: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/selector/graphics/chooser/UIGChooserModel.cpp	(revision 45296)
@@ -1458,5 +1458,5 @@
     /* Confirm machine removal: */
     int iResultCode = msgCenter().confirmMachineRemoval(machines);
-    if (iResultCode == QIMessageBox::Cancel)
+    if (iResultCode == AlertButton_Cancel)
         return;
 
@@ -1466,5 +1466,5 @@
         /* Get iterated machine: */
         CMachine &machine = machines[iMachineIndex];
-        if (iResultCode == QIMessageBox::Yes)
+        if (iResultCode == AlertButton_Yes)
         {
             /* Unregister machine first: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 45295)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 45296)
@@ -3046,7 +3046,7 @@
         {
             int iAnswer = msgCenter().askAboutHardDiskAttachmentCreation(strControllerName, this);
-            if (iAnswer == QIMessageBox::Yes)
+            if (iAnswer == AlertButton_Yes)
                 strMediumId = getWithNewHDWizard();
-            else if (iAnswer == QIMessageBox::No)
+            else if (iAnswer == AlertButton_No)
                 strMediumId = vboxGlobal().openMediumWithFileOpenDialog(UIMediumType_HardDisk, this, strMachineFolder);
             break;
@@ -3055,7 +3055,7 @@
         {
             int iAnswer = msgCenter().askAboutOpticalAttachmentCreation(strControllerName, this);
-            if (iAnswer == QIMessageBox::Yes)
+            if (iAnswer == AlertButton_Yes)
                 strMediumId = vboxGlobal().openMediumWithFileOpenDialog(UIMediumType_DVD, this, strMachineFolder);
-            else if (iAnswer == QIMessageBox::No)
+            else if (iAnswer == AlertButton_No)
                 strMediumId = vboxGlobal().findMedium(strMediumId).id();
             break;
@@ -3064,7 +3064,7 @@
         {
             int iAnswer = msgCenter().askAboutFloppyAttachmentCreation(strControllerName, this);
-            if (iAnswer == QIMessageBox::Yes)
+            if (iAnswer == AlertButton_Yes)
                 strMediumId = vboxGlobal().openMediumWithFileOpenDialog(UIMediumType_Floppy, this, strMachineFolder);
-            else if (iAnswer == QIMessageBox::No)
+            else if (iAnswer == AlertButton_No)
                 strMediumId = vboxGlobal().findMedium(strMediumId).id();
             break;