Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 45316)
@@ -1191,89 +1191,70 @@
 }
 
-void UIMessageCenter::cannotCreateMachine(const CVirtualBox &vbox, QWidget *pParent /* = 0 */)
-{
-    message(
-        pParent ? pParent : mainWindowShown(),
-        MessageType_Error,
-        tr("Failed to create a new virtual machine."),
-        formatErrorInfo(vbox)
-    );
-}
-
-void UIMessageCenter::cannotCreateMachine(const CVirtualBox &vbox,
-                                          const CMachine &machine,
-                                          QWidget *pParent /* = 0 */)
-{
-    message(
-        pParent ? pParent : mainWindowShown(),
-        MessageType_Error,
-        tr("Failed to create a new virtual machine <b>%1</b>.")
-            .arg(machine.GetName()),
-        formatErrorInfo(vbox)
-    );
-}
-
-void UIMessageCenter::cannotRegisterMachine(const CVirtualBox &vbox,
-                                            const CMachine &machine,
-                                            QWidget *pParent)
-{
-    message(pParent ? pParent : mainWindowShown(),
-            MessageType_Error,
+void UIMessageCenter::cannotCreateMachine(const CVirtualBox &vbox, QWidget *pParent /*= 0*/)
+{
+    message(pParent ? pParent : mainWindowShown(), MessageType_Error,
+            tr("Failed to create a new virtual machine."),
+            formatErrorInfo(vbox));
+}
+
+void UIMessageCenter::cannotRegisterMachine(const CVirtualBox &vbox, const QString &strMachineName, QWidget *pParent /*= 0*/)
+{
+    message(pParent ? pParent : mainWindowShown(), MessageType_Error,
             tr("Failed to register the virtual machine <b>%1</b>.")
-            .arg(machine.GetName()),
+               .arg(strMachineName),
             formatErrorInfo(vbox));
 }
 
-void UIMessageCenter::cannotCreateClone(const CMachine &machine,
-                                        QWidget *pParent /* = 0 */)
-{
-    message(
-        pParent ? pParent : mainWindowShown(),
-        MessageType_Error,
-        tr("Failed to clone the virtual machine <b>%1</b>.")
-            .arg(machine.GetName()),
-        formatErrorInfo(machine)
-    );
-}
-
-void UIMessageCenter::cannotCreateClone(const CMachine &machine,
-                                        const CProgress &progress,
-                                        QWidget *pParent /* = 0 */)
-{
-    AssertWrapperOk(progress);
-
-    message(pParent ? pParent : mainWindowShown(),
-        MessageType_Error,
-        tr("Failed to clone the virtual machine <b>%1</b>.")
-            .arg(machine.GetName()),
-        formatErrorInfo(progress.GetErrorInfo())
-    );
-}
-
-void UIMessageCenter::cannotOverwriteHardDiskStorage(QWidget *pParent,
-                                                     const QString &strLocation)
-{
-    message(pParent, MessageType_Info,
-        tr("<p>The hard disk storage unit at location <b>%1</b> already "
-           "exists. You cannot create a new virtual hard disk that uses this "
-           "location because it can be already used by another virtual hard "
-           "disk.</p>"
-           "<p>Please specify a different location.</p>")
-        .arg(strLocation));
-}
-
-void UIMessageCenter::cannotCreateHardDiskStorage(QWidget *pParent,
-                                                  const CVirtualBox &vbox,
-                                                  const QString &strLocation,
-                                                  const CMedium &medium,
-                                                  const CProgress &progress)
-{
-    message(pParent, MessageType_Error,
-        tr("Failed to create the hard disk storage <nobr><b>%1</b>.</nobr>")
-        .arg(strLocation),
-        !vbox.isOk() ? formatErrorInfo(vbox) :
-        !medium.isOk() ? formatErrorInfo(medium) :
-        !progress.isOk() ? formatErrorInfo(progress) :
-        formatErrorInfo(progress.GetErrorInfo()));
+void UIMessageCenter::cannotCreateClone(const CMachine &machine, QWidget *pParent /*= 0*/)
+{
+    /* Preserve error-info: */
+    QString strErrorInfo = formatErrorInfo(machine);
+    /* Show the message: */
+    message(pParent ? pParent : mainWindowShown(), MessageType_Error,
+            tr("Failed to clone the virtual machine <b>%1</b>.")
+               .arg(machine.GetName()),
+            strErrorInfo);
+}
+
+void UIMessageCenter::cannotCreateClone(const CProgress &progress, const QString &strMachineName, QWidget *pParent /* = 0 */)
+{
+    message(pParent ? pParent : mainWindowShown(), MessageType_Error,
+            tr("Failed to clone the virtual machine <b>%1</b>.")
+               .arg(strMachineName),
+            !progress.isOk() ? formatErrorInfo(progress) : formatErrorInfo(progress.GetErrorInfo()));
+}
+
+void UIMessageCenter::cannotOverwriteHardDiskStorage(const QString &strLocation, QWidget *pParent /*= 0*/)
+{
+    message(pParent ? pParent : mainWindowShown(), MessageType_Info,
+            tr("<p>The hard disk storage unit at location <b>%1</b> already exists. "
+               "You cannot create a new virtual hard disk that uses this location "
+               "because it can be already used by another virtual hard disk.</p>"
+               "<p>Please specify a different location.</p>")
+               .arg(strLocation));
+}
+
+void UIMessageCenter::cannotCreateHardDiskStorage(const CVirtualBox &vbox, const QString &strLocation, QWidget *pParent /*= 0*/)
+{
+    message(pParent ? pParent : mainWindowShown(), MessageType_Error,
+            tr("Failed to create the hard disk storage <nobr><b>%1</b>.</nobr>")
+               .arg(strLocation),
+            formatErrorInfo(vbox));
+}
+
+void UIMessageCenter::cannotCreateHardDiskStorage(const CMedium &medium, const QString &strLocation, QWidget *pParent /*= 0*/)
+{
+    message(pParent ? pParent : mainWindowShown(), MessageType_Error,
+            tr("Failed to create the hard disk storage <nobr><b>%1</b>.</nobr>")
+               .arg(strLocation),
+            formatErrorInfo(medium));
+}
+
+void UIMessageCenter::cannotCreateHardDiskStorage(const CProgress &progress, const QString &strLocation, QWidget *pParent /*= 0*/)
+{
+    message(pParent ? pParent : mainWindowShown(), MessageType_Error,
+            tr("Failed to create the hard disk storage <nobr><b>%1</b>.</nobr>")
+               .arg(strLocation),
+            !progress.isOk() ? formatErrorInfo(progress) : formatErrorInfo(progress.GetErrorInfo()));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.h	(revision 45316)
@@ -269,11 +269,11 @@
     /* API: Wizards warnings: */
     void cannotCreateMachine(const CVirtualBox &vbox, QWidget *pParent = 0);
-    void cannotCreateMachine(const CVirtualBox &vbox, const CMachine &machine, QWidget *pParent = 0);
-    void cannotRegisterMachine(const CVirtualBox &vbox, const CMachine &machine, QWidget *pParent);
+    void cannotRegisterMachine(const CVirtualBox &vbox, const QString &strMachineName, QWidget *pParent = 0);
     void cannotCreateClone(const CMachine &machine, QWidget *pParent = 0);
-    void cannotCreateClone(const CMachine &machine, const CProgress &progress, QWidget *pParent = 0);
-    void cannotOverwriteHardDiskStorage(QWidget *pParent, const QString &strLocation);
-    void cannotCreateHardDiskStorage(QWidget *pParent, const CVirtualBox &vbox, const QString &strLocation,
-                                     const CMedium &medium, const CProgress &progress);
+    void cannotCreateClone(const CProgress &progress, const QString &strMachineName, QWidget *pParent = 0);
+    void cannotOverwriteHardDiskStorage(const QString &strLocation, QWidget *pParent = 0);
+    void cannotCreateHardDiskStorage(const CVirtualBox &vbox, const QString &strLocation,QWidget *pParent = 0);
+    void cannotCreateHardDiskStorage(const CMedium &medium, const QString &strLocation, QWidget *pParent = 0);
+    void cannotCreateHardDiskStorage(const CProgress &progress, const QString &strLocation, QWidget *pParent = 0);
     void warnAboutCannotRemoveMachineFolder(QWidget *pParent, const QString &strFolderName);
     void warnAboutCannotRewriteMachineFolder(QWidget *pParent, const QString &strFolderName);
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVD.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVD.cpp	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVD.cpp	(revision 45316)
@@ -62,27 +62,26 @@
     CVirtualBox vbox = vboxGlobal().virtualBox();
 
-    /* Create new virtual-disk: */
+    /* Create new virtual hard-disk: */
     CMedium virtualDisk = vbox.CreateHardDisk(mediumFormat.GetName(), strMediumPath);
-    CProgress progress;
     if (!vbox.isOk())
     {
-        msgCenter().cannotCreateHardDiskStorage(this, vbox, strMediumPath, virtualDisk, progress);
+        msgCenter().cannotCreateHardDiskStorage(vbox, strMediumPath, this);
         return false;
     }
 
-    QVector<KMediumVariant> l_variants(sizeof(uVariant)*8);
-
-    for (int i = 0; i < l_variants.size(); ++i)
+    /* Compose medium-variant: */
+    QVector<KMediumVariant> variants(sizeof(qulonglong)*8);
+    for (int i = 0; i < variants.size(); ++i)
     {
         qulonglong temp = uVariant;
         temp &= 1<<i;
-        l_variants [i] = (KMediumVariant)temp;
+        variants[i] = (KMediumVariant)temp;
     }
 
     /* Copy existing virtual-disk to the new virtual-disk: */
-    progress = sourceVirtualDisk.CloneTo(virtualDisk, l_variants, CMedium());
-    if (!virtualDisk.isOk())
+    CProgress progress = sourceVirtualDisk.CloneTo(virtualDisk, variants, CMedium());
+    if (!sourceVirtualDisk.isOk())
     {
-        msgCenter().cannotCreateHardDiskStorage(this, vbox, strMediumPath, virtualDisk, progress);
+        msgCenter().cannotCreateHardDiskStorage(sourceVirtualDisk, strMediumPath, this);
         return false;
     }
@@ -94,5 +93,5 @@
     if (!progress.isOk() || progress.GetResultCode() != 0)
     {
-        msgCenter().cannotCreateHardDiskStorage(this, vbox, strMediumPath, virtualDisk, progress);
+        msgCenter().cannotCreateHardDiskStorage(progress, strMediumPath, this);
         return false;
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDPageBasic4.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDPageBasic4.cpp	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDPageBasic4.cpp	(revision 45316)
@@ -234,5 +234,5 @@
     fResult = !QFileInfo(strMediumPath).exists();
     if (!fResult)
-        msgCenter().cannotOverwriteHardDiskStorage(this, strMediumPath);
+        msgCenter().cannotOverwriteHardDiskStorage(strMediumPath, this);
 
     if (fResult)
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDPageExpert.cpp	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevd/UIWizardCloneVDPageExpert.cpp	(revision 45316)
@@ -263,5 +263,5 @@
     fResult = !QFileInfo(strMediumPath).exists();
     if (!fResult)
-        msgCenter().cannotOverwriteHardDiskStorage(this, strMediumPath);
+        msgCenter().cannotOverwriteHardDiskStorage(strMediumPath, this);
 
     /* Try to copy virtual-disk: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVM.cpp	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/clonevm/UIWizardCloneVM.cpp	(revision 45316)
@@ -142,5 +142,5 @@
     if (!progress.isOk() || progress.GetResultCode() != 0)
     {
-        msgCenter().cannotCreateClone(srcMachine, progress, this);
+        msgCenter().cannotCreateClone(progress, srcMachine.GetName(), this);
         return false;
     }
@@ -150,5 +150,5 @@
     if (!vbox.isOk())
     {
-        msgCenter().cannotRegisterMachine(vbox, cloneMachine, this);
+        msgCenter().cannotRegisterMachine(vbox, cloneMachine.GetName(), this);
         return false;
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 45316)
@@ -62,31 +62,29 @@
     AssertReturn(uSize > 0, false);
 
-    /* Get vbox object: */
+    /* Get VBox object: */
     CVirtualBox vbox = vboxGlobal().virtualBox();
 
-    /* Create new virtual disk: */
+    /* Create new virtual hard-disk: */
     CMedium virtualDisk = vbox.CreateHardDisk(mediumFormat.GetName(), strMediumPath);
-    CProgress progress;
     if (!vbox.isOk())
     {
-        msgCenter().cannotCreateHardDiskStorage(this, vbox, strMediumPath, virtualDisk, progress);
+        msgCenter().cannotCreateHardDiskStorage(vbox, strMediumPath, this);
         return false;
     }
 
-    QVector<KMediumVariant> l_variants(sizeof(qulonglong)*8);
-
-    for (int i = 0; i < l_variants.size(); ++i)
+    /* Compose medium-variant: */
+    QVector<KMediumVariant> variants(sizeof(qulonglong)*8);
+    for (int i = 0; i < variants.size(); ++i)
     {
         qulonglong temp = uVariant;
         temp &= 1<<i;
-        l_variants [i] = (KMediumVariant)temp;
+        variants[i] = (KMediumVariant)temp;
     }
 
-    /* Create base storage for the new hard disk: */
-    progress = virtualDisk.CreateBaseStorage(uSize, l_variants);
-
+    /* Create base storage for the new virtual-disk: */
+    CProgress progress = virtualDisk.CreateBaseStorage(uSize, variants);
     if (!virtualDisk.isOk())
     {
-        msgCenter().cannotCreateHardDiskStorage(this, vbox, strMediumPath, virtualDisk, progress);
+        msgCenter().cannotCreateHardDiskStorage(virtualDisk, strMediumPath, this);
         return false;
     }
@@ -98,5 +96,5 @@
     if (!progress.isOk() || progress.GetResultCode() != 0)
     {
-        msgCenter().cannotCreateHardDiskStorage(this, vbox, strMediumPath, virtualDisk, progress);
+        msgCenter().cannotCreateHardDiskStorage(progress, strMediumPath, this);
         return false;
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic3.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic3.cpp	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageBasic3.cpp	(revision 45316)
@@ -398,5 +398,5 @@
     fResult = !QFileInfo(strMediumPath).exists();
     if (!fResult)
-        msgCenter().cannotOverwriteHardDiskStorage(this, strMediumPath);
+        msgCenter().cannotOverwriteHardDiskStorage(strMediumPath, this);
 
     if (fResult)
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageExpert.cpp	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageExpert.cpp	(revision 45316)
@@ -277,5 +277,5 @@
     fResult = !QFileInfo(strMediumPath).exists();
     if (!fResult)
-        msgCenter().cannotOverwriteHardDiskStorage(this, strMediumPath);
+        msgCenter().cannotOverwriteHardDiskStorage(strMediumPath, this);
 
     /* Try to create virtual-disk: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 45315)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVM.cpp	(revision 45316)
@@ -190,5 +190,5 @@
     if (!vbox.isOk())
     {
-        msgCenter().cannotCreateMachine(vbox, m_machine, this);
+        msgCenter().cannotRegisterMachine(vbox, m_machine.GetName(), this);
         return false;
     }